diff mbox series

[2/3] generic: add race test that mmap write to source of reflink

Message ID 20211115034108.1328167-3-ruansy.fnst@fujitsu.com (mailing list archive)
State New, archived
Headers show
Series generic: add some race tests for mmap read/write | expand

Commit Message

Shiyang Ruan Nov. 15, 2021, 3:41 a.m. UTC
Test for races or FS corruption when mmap writing to a file that's also
the source of a reflink operation. (MMAP version of generic/167,166)

Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com>
---
 tests/generic/931     | 64 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/931.out |  4 +++
 2 files changed, 68 insertions(+)
 create mode 100755 tests/generic/931
 create mode 100644 tests/generic/931.out
diff mbox series

Patch

diff --git a/tests/generic/931 b/tests/generic/931
new file mode 100755
index 00000000..715ac085
--- /dev/null
+++ b/tests/generic/931
@@ -0,0 +1,64 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# FS QA Test No. xxx
+#
+# Test for races or FS corruption when mmap writing to a file that's also
+# the source of a reflink operation. (MMAP version of generic/167,166)
+#
+. ./common/preamble
+_begin_fstest auto clone
+
+_register_cleanup "_cleanup" BUS
+
+# Import common functions.
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_require_scratch_reflink
+_require_cp_reflink
+
+echo "Format and mount"
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+finished_file=/tmp/finished
+rm -rf $finished_file
+mkdir $testdir
+
+loops=1024
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize file"
+echo >> $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_scratch_cycle_mount
+
+# Snapshot creator...
+snappy() {
+	n=0
+	while [ ! -e $finished_file ]; do
+		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"
+		res=$?
+		echo "$out" | grep -q "No space left" && break
+		test -n "$out" && echo "$out"
+		test $res -ne 0 && break
+		n=$((n + 1))
+	done
+}
+
+echo "Snapshot a file undergoing mmap rewrite"
+snappy &
+seq $nr_loops -1 0 | while read i; do
+	$XFS_IO_PROG -f -c "mmap -rw $((i * blksz)) $blksz" \
+		-c "mwrite -S 0x63 $((i * blksz)) $blksz" $testdir/file1 >> $seqres.full
+done
+touch $finished_file
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/931.out b/tests/generic/931.out
new file mode 100644
index 00000000..b224e6ad
--- /dev/null
+++ b/tests/generic/931.out
@@ -0,0 +1,4 @@ 
+QA output created by 931
+Format and mount
+Initialize file
+Snapshot a file undergoing mmap rewrite